use strict;
use warnings;

#--------------------------------------------------------------------------------------------------------------
# Show Todo
#--------------------------------------------------------------------------------------------------------------

sub show_todo {
	my $todo_txt =
"==============
=- 4.0 Todo -=
==============

High

* code cleanup/ optimization
* rename all flags nicely and uppercase.

Medium

* none

Low

* none

==============
=- 5.0 Todo -=
==============

High:

* block renaming.
* act as a passthrough for ed2k links (cleanup before adding 2 ed2k)
* media tag support for ogg.

Medium:

* Process media playlist: tidy file names, tags and update playlist entries.

* right click menu options:
|- file properties
|- delete
|- cut & paste ?
\- PSR (prefrom suggested rename for this file now)

Low:

* jpeg and other picture tag support.

==================
=- Known Issues -=
==================

* recode bookmarks.pm (it has a few dirty hacks in it atm)

* truncate from middle will round down to nearest even number more often than
  not - this is not a problem in my eyes.

* Unicode characters are supported, but some weirdness may occur on some
  systems depending on systems unicode support & codepages supported.
  Ive encountered no unicode show stoppers myself.
";
        my $top = $main::mw -> Toplevel();
        $top -> title("Todo List");

        my $top_lab = $top -> Label(
        	-text=>"Todo List for Namefix.pl $main::version",
        	-font=>$main::dialog_title_font
        ) -> grid(
        	-row => 1,
        	-column => 1,
        	-columnspan => 2
        );

        my $txt = $top -> Scrolled(
        	"ROText",
        	-scrollbars=>"osoe",
        	-font=>$main::dialog_font
        )
        -> grid(
        	-row => 2,
        	-column => 1,
        	-columnspan => 2
        );

        $txt->menu(undef);
        $txt -> insert('end', "$todo_txt");

        my $but_close = $top -> Button(
        	-text=>"Close",
        	-activebackground => "white",
        	-command => sub {
        		destroy $top;
        	}
        )
        -> grid(
        	-row => 4,
        	-column => 1,
        	-columnspan => 2
        );

	$top->resizable(0,0);
}

1;